#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct BitMap
{
  // * BMP Header
  short Type;         // ID field (42h, 4Dh) ; "BM"
  short Size;         // Size of the BMP file
  short SizePad;
  short Reserve1;     // Application specific
  short Reserve2;     // Application specific
  short OffBits;      // Offset where the pixel array (bitmap data) can be found
  short OffBitsPad;
  // * DIB Header
  short biSize;       // Number of bytes in the DIB header (from this point)
  short biSizePad;
  short biWidth;      // Width of the bitmap in pixels
  short biWidthPad; 
  short biHeight;     // Height of the bitmap in pixels
  short biHeightPad;     
  short biPlanes;     // Number of color planes being used
  short biBitCount;   // Number of bits per pixel
  short biCompression;  // BI_RGB, no pixel array compression used
  short biCompressionPad;  
  short biSizeImage;    // Size of the raw data in the pixel array
  short biSizeImagePad; 
  int biXPelsPerMeter;// Horizontal resolution of the image
  int biYPelsPerMeter;// Vertical resolution of the image
  int biClrUsed;      // Number of colors in the palette
  int biClrImportant; // 0 means all colors are important
} Header;

int main(int argc, char **argv)
{

  FILE *BMPFile;
  /* check test.bmp and open it*/
  if(NULL != (BMPFile = fopen ("../ide_64/workspace/testbitmap/test.bmp", "rb")))
  {
  } else if (NULL != (BMPFile = fopen ("../ide/workspace/testbitmap/test.bmp", "rb")))
  {
  } else
  {
	  printf("test.bmp open fail, please check!!!");
	  return;
  }
  
  memset(&Header, 0, sizeof(Header));
  
  fread(&Header, 54, 1, BMPFile);
  //fread(&Header, sizeof(Header), 1, BMPFile);
  //printf("\nHeader size test:%d\n", sizeof(Header)); 

  printf("\nType:%d\n", Header.Type); 
  printf("Size:%d\n", Header.Size);  
  printf("Reserve1:%d\n", Header.Reserve1);  
  printf("Reserve2:%d\n", Header.Reserve2);
  printf("OffBits:%d\n", Header.OffBits); 
  printf("biSize:%d\n", Header.biSize);      
  printf("Width:%d\n", Header.biWidth);    
  printf("Height:%d\n", Header.biHeight);  
  printf("biPlanes:%d\n", Header.biPlanes);  
  printf("biBitCount:%d\n", Header.biBitCount);
  printf("biCompression:%d\n", Header.biCompression);  
  printf("biSizeImage:%d\n", Header.biSizeImage);  
  printf("biXPelsPerMeter:%d\n", Header.biXPelsPerMeter);  
  printf("biYPelsPerMeter:%d\n", Header.biYPelsPerMeter);  
  printf("biClrUsed:%d\n", Header.biClrUsed);  
  printf("biClrImportant:%d\n\n", Header.biClrImportant);  

  fclose(BMPFile);
  
  return 0;
}

